%%%%%%%%%% Reinforcement Problem 10.14 %%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Fourth-order modal system ----
%
clear
disp('Reinforcement Problem 10.14')
Ts = 0.1 
A = diag([0.9048 0.8187 0.7788 1])
B = [0.0476; 0.0476; 0.0885; 0.5]
C = [ 1 2 -1 1 ]
D = 0
Gp = ss(A,B,C,D,Ts)
% (a) design full-state feedback and observer gains
p_s = [0.7 0.75 0.85 0.95]'
F = place(A,B,p_s)
A_cl = A-B*F
p_o = [0.5 0.65 0.78 0.92]'
L = place(A',C',p_o)'
A_ob = A-L*C
eig(A_ob)
% (b) build observer-controller according to (10.5) and (10.6)
A_oc = A-B*F-L*C
Goc = ss(A_oc,-L,-F,0,Ts)
Goc_poles = pole(Goc)
Goc_zeros = tzero(Goc)
figure, bode(Goc)
GpGc = Gp*Goc
Gcl = feedback(GpGc,1,-1)
cl_loop_poles = pole(Gcl)
% (c) pre-gain for unity DC gain
lfg = dcgain(Gcl)
N = 1/lfg
% incorporate N in series with closed-loop system transfer function 
T_ref = N*Gcl;
t = [0:Ts:4];
r = 0*t;
z0 = [1 2 0 1 0 0 0 0]'   % initial condition
[y,t,z] = lsim(T_ref,r,t,z0);
figure
plot(t,z(:,1:4),'o',t,z(:,5:8),'+'), grid
[ys,t,z] = step(T_ref,t);
figure
step(T_ref,t)
%%%%%%%%%%