%%%%%%%%%%%%%%%%%% Example 2.1 %%%%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Build G(z) as TF object ----
%
clear
disp('Example 2.1')
numG = [0.1 0.03 -0.07]           % enter transfer function numerator
denG = [1 -2.7 2.42 -0.72]        % ...and denominator polynomials
%-- Create G(z) as a discrete-time TF object with unspecified sampling period
G = tf(numG,denG,-1)
get(G)                            % Show properties of the TF object
disp('******>'), pause
[nn,dd] = tfdata(G,'v')
[zz,pp,kk] = zpkdata(G,'v')       % Extract num & den from the TF object
ucircle, hold on                  % show unit circle in z-plane
pzmap(G), hold off                % draw pole-zero plot

set_xo_size                       % make larger X's and O's
title('Example 2.1')
%%%%%%%%%%