%%%%%%%%%%%%%%%%%% Example 2.5 %%%%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ---- Response due to complex poles on the unit circle ----
%
clear
disp('Example 2.5')
Ts = 1;
numG = [1 0.5];                                  % numerator of G(z)
denG = conv([1 -exp(i*pi/3)],[1 -exp(-i*pi/3)]); % denominator of G(z)
G1 = tf(numG,denG,Ts)              % build G(z) as TF object for Ts = 1
[y1,k1] = impulse(G1,20);          % compute response and time vector
figure
stem(k1,y1,'filled');grid          % plot response for Ts = 1 s
title('Example 2.5: Sampling period = 1.0 s')
xlabel('Time (s)')
ylabel('Amplitude')
disp('Plotting impulse response with a sampling time of 1.0 s')
disp('******>'), pause

%------ change sampling period to Ts = 0.5 s --------
Ts = 0.5;
G05 = tf(numG,denG,Ts)             % rebuild G(z) as TF object for Ts = 0.5
[y05,k05] = impulse(G05,20);       % compute response and time vector
figure
stem(k05,y05,'filled');grid        % plot response for Ts = 0.5
title('Example 2.5: Sampling period = 0.5 s')
xlabel('Time (s)')
ylabel('Amplitude')
disp('Plotting impulse response with a sampling time of 0.5 s')
%%%%%%%%%%