%%%%%%%%%%% Reinforcement Problem 2.3 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%	--- Fourth-order System with complex poles ---
%
clear
disp('Reinforcement Problem 2.3')
% Create G(z) as a discrete-time ZPK object 
%                with unspecified sampling period
zz = [-0.2; 0.4]
pp = [0.6; -0.5 + 0.75i; -0.5 - 0.75i; -0.3]
kk = 150
G  = zpk(zz,pp,kk,-1)
get(G)                      % Show properties of the ZPK LTI object
[nn,dd] = tfdata(G,'v')     % Extract num & den from the LTI object
GG = tf(G)			        % convert from ZPK form to TF form
[z,p,k] = zpkdata(GG,'v')   % Extract zeros, poles, & gain from the LZPK form
figure
ucircle                     % show unit circle in z-plane
hold on
pzmap(GG)                   % draw pole-zero plot using TF form
hold off
set_xo_size					% make larger X's and O's
text('Units','norm','Pos',[0.02,0.95],'Str','Reinforcement Problem 2.3')
%%%%%%%%%%