%%%%%%%%%% Comprehensive Problem 3.4(b) %%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Hydro-turbine System

clear
disp('Comprehensive Problem 3.4b')
disp('PD controller design for hydro-turbine system')

dhydro  % read data
disp('discrete-time transfer function')
Gz = tf(dnum,dden,Ts)  % form tf object
disp('*****>'), pause

disp(' ')
disp('PD controller with K_p=0.5 and K_D = 0.3')
K_p = 0.5; K_D = 0.3;
G_c = K_p*(1 + tf(K_D*[1 -1],Ts*[1 0],Ts))
disp('*****>'), pause

disp('Open-loop compensated system')
G_OL = Gz*G_c 
disp('*****>'), pause

disp('Closed-loop system transfer function ')
T_PD = feedback(G_OL,1)
disp('*****>'), pause

disp('Poles of closed-loop system')
pole(T_PD)
disp('Magnitude of closed-loop poles')
abs(ans)
disp('Zeros of closed-loop system')
tzero(T_PD)
disp('DC gain of closed-loop system')
dcgain(T_PD)
disp('*****>'), pause

disp('Step response of hydro-turbine to step reference input')
figure
[y,dt] = step(T_PD);
stem(dt,y,':')
xlabel('Time (s)')
ylabel('Amplitude')
title('CP3.4b: Closed-loop Response of Power P to Unit Step of Reference Input')
grid
disp('*****>'), pause

disp('end of Comprehensive Problem 3.4b')
%%%%%%%%%%