%%%%%%%%%% Reinforcement Problem 3.16 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Gain variation ----
%
clear
disp('Reinforcement Problem 3.16')
Ts = 1;
%---- H(z) is same for each case
H = tf([1 -0.8],[2 1],Ts)              % feedback path in TF form
dtime = 0:Ts:20;
figure
K = [1 2 5 10];

%-------- run 4 cases, plotting step responses as subplots ----
for ii = 1:4,
  kG = K(ii)
  G = tf(kG,conv([1 0],[10 -2 1]),Ts)  % forward path in TF form
  T = feedback(G,H)                    % closed-loop system
  y = step(T,dtime);                   % compute step response
  subplot(2,2,ii)
  stem(dtime,y,':','filled');grid      % plot step response
  title(['Reinf 3.16: K = ',num2str(kG)])
end

%----- rerun the 4 cases, plotting CL poles in z plane -----
figure
ucircle;grid
hold on
for ii = 1:4,
  kG = K(ii);
  disp(['==== K = ',num2str(kG),' ===='])
  G = tf(kG,conv([1 0],[10 -2 1]),Ts)  % forward path in TF form
  T = feedback(G,H)                    % closed-loop system
  [zT,pT,kT] = zpkdata(T,'v')          % CL zeros,poles,gain
  [magpT,thetapT] = xy2p(pT)           % polar form of CL poles
  plot(pT,'*')
end
hold off
title('Pole-zero plot for Reinforcement Problem 3.16')
xlabel('Real part of z')
ylabel('Imaginary part of z')
%%%%%%%%%%