%%%%%%%%%% Reinforcement Problem 3.18 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  ---- Positive feedback ----
%
clear
disp('Reinforcement Problem 3.18')
Ts = 1;
a = 0.9*exp(j*pi/4)
denG = conv([1 -a],[1 -conj(a)])
G = tf(0.2*[1 -0.85],denG,Ts)       % forward transfer function
denH = conv([1 -0.8],[1 -0.1])
H = tf([1 -0.3],denH,Ts)            % feedback path
T = feedback(G,H,+1)                % positive feedback
[zT,pT,kT] = zpkdata(T,'v')         % CL zeros,poles,gain
[magpT,thetapT] = xy2p(pT)          % polar form of CL poles
k = 0:Ts:30;
y = step(T,k);                      % compute step response
figure
plot(k,y,'*');grid         % plot step response
title('Step response for Reinforcement Problem 3.18')
xlabel('Discrete time k')
%%%%%%%%%%
