%%%%%%%%%%%%%%%%%% Example 4.1 %%%%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Building a state-space model ----
%
clear
disp('Example 4.1')
Ts = 0.1;                     % sampling period
A = [ 0.98   0.095   0.003; -0.38   0.89   0.04; 0   0   0.14]
B = [0.002; 0.05; 0.9]
C = [1 0 0]
D = 0
disp('******>'), pause 
Gss = ss(A,B,C,D,Ts)          % set up model in SS form
disp('******>'), pause 
Gtf = tf(Gss)                 % convert to TF form
disp('******>'), pause 
Gss1 = ss(Gtf)                % convert back to SS form
disp('******>'), pause 
[A1,B1,C1,D1] = ssdata(Gss1)  % extract state-space matrices
disp('******>'), pause 
Gzpk = zpk(Gss)               % convert to ZPK form
Gss2 = ss(Gzpk)               % convert back to SS form
disp('******>'), pause 
[A2,B2,C2,D2] = ssdata(Gss2)  % extract state-space matrices
%%%%%%%%%%


