%%%%%%%%%%% Reinforcement Problem 4.7 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Fourth-order system with nonzero D ----
%
clear
disp('Reinforcement Problem 4.7')
Ts = 0.5;
A = [-0.819 0.148 0.0277 0.00398
       0    0.670 0.255  0.0535
       0    0     0.606  0.238  
       0    0      0     0.368];
B = [0.00111
     0.0210
     0.155
     0.632]; 
C = [1 0 1 0];
D = 0.5;

%----- build SS model
Gss = ss(A,B,C,D,Ts)
disp('SS object Gss')
disp('*******>')
pause

%----- convert from SS form --> ZPK form
Gzpk = zpk(Gss)
disp('ZPK object zpk')
disp('*******>')
pause

%----- extract zeros, poles, gain from ZPK object
[z,p,k] = zpkdata(Gzpk,'v')
[magz,thetaz] = xy2p(z)
disp('zeros, poles, gain from ZPK object')
disp('*******>')
pause

%----- compare with results from these cmds
zz = tzero(Gss)
pp  = pole(Gss)
disp('zeros from tzero cmd on SS object and')
disp('.......poles from pole cmd on SS object')
disp('*******>')
pause

disp('eigenvalues of A are:')
disp(eig(A))

%---- do a PZ map
figure
ucircle
axis equal
hold on
pzmap(Gss)
hold off
title('Reinforcement Problem 4.7p')
%%%%%%%%%%
