%%%%%%%%%%% Reinforcement Problem 4.9 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Third-order system ----
%
clear
disp('Reinforcement Problem 4.9')
Ts = 0.4;
A = [-0.027 -3.42 -5.07
      0.085  0.56 -0.71
      0.012  0.17  0.94];
B = [0.85
     0.12
       0];
C = [2 7 5]; 
D = 0;

%----- build as SS object & display zeros & poles
G = ss(A,B,C,D,Ts)
[z,p,k] = zpkdata(G,'v');
disp('zeros are:')
disp(z)
disp('magnitudes & angles (rad) of poles are:')
disp([abs(p) angle(p)])

%----- select time vector & do responses
k = [0:Ts:6]';
yi= impulse(G,k);
ys=step(G,k);

figure
subplot(2,1,1)
stem(k,yi,'filled'); grid
title('Reinforcement Problem 4.9')
xlabel('Time (s)') 
legend('Impulse response')
%
subplot(2,1,2)
stem(k,ys,'filled'); grid
legend('Step response')
xlabel('Time (s)') 
%%%%%%%%%%

