%%%%%%%%%%%%%%%%%% Example 5.4 %%%%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Output of a zero-order hold ----
%
clear
disp('Example 5.4')

fs = 10, Ts = 1/fs;           % sampling frequency and period
t = [0:Ts:1]';                % time points from 0 to 1 s
e = sin(2*pi*t);              % 1-Hz signal
figure
dplot(t,e), hold on           % sampled signal
stairs(t,e)                   % ZOH output
tt = [0:0.01:1]';             % take tt as continuous time
ec = sin(2*pi*tt);            % 1-Hz signal
plot(tt,ec,'--'), hold off    % input sine wave
xlabel('Time (s)')
ylabel('Amplitude')
title('Input, sampled signal, and ZOH output for Example 5.4')
text(0.52,0.50,'ZOH output')
text(0.47,-0.3,'Input')
text(0.22,-0.7,'triangles are sampled signal')
%%%%%%%%%%