%%%%%%%%%%% Reinforcement Problem 5.2 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Sinusoidal signal ----
%
clear
disp('Reinforcement Problem 5.2')

Ts = 0.04;
kT = [0:Ts:1]';            % sampling at 25 Hz
t = [0:0.02:1]';           % continuous time
e_k = exp(-kT).*cos(4*pi*kT) + 0.5*sin(10*pi*kT - pi/180*60); % continuous signal e(t)
e_t = exp(-t).*cos(4*pi*t) + 0.5*sin(10*pi*t - pi/180*60);    % continuous signal e(t)

figure
dplot(kT,e_k);grid         % plot sampled signal
hold on
plot(t,e_t,'--')           % plot continuous signal with dashes
hold off
xlabel('Time (s)')
title('Reinforcement Problem 5.2: Sampled signal e^*(k) and continuous signal e(t)')
%%%%%%%%%%