%%%%%%%%%%% Reinforcement Problem 7.3 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Non-ideal sensor ----
%
clear
disp('Reinforcement Problem 7.3')
Ts = 0.1
Hs = tf(20,[1 20])               % continuous sensor in TF form
Gs = tf(10,conv([1 0],[1 10]))   % continuous plant in TF form
Gz = c2d(Gs,Ts,'zoh')            % discretize plant with ZOH
Gc = tf([1 -0.5],[1 -0.8],0.1)   % discrete controller
HGz = c2d(Hs*Gs,Ts,'zoh')        % discretize combined Hs & Gs
Gcl = Gz*Gc/(1+HGz*Gc)           % CL transfer function
Gcl = minreal(Gcl)               % eliminate duplicate states
damp(Gcl)
[y,t] = step(Gcl);
[Moa,tpa,tra,tsa,essa] = kstats(t,y,1)
%%%%%%%%%%