%%%%%%%%%%%%%%%%% Example 8.1(a) %%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ----  Proportional-only design  ----
%
clear
disp('Example 8.1(a)')

Ts = 0.1;			             % sampling period
Gp_s = tf(4,conv([2 1],[0.5 1])) % continuous process
H_s = tf(1,[0.05 1])		     % continuous sensor
HGp_s = H_s*Gp_s                 % continous plant
HGp_z = c2d(HGp_s,Ts,'zoh')      % discrete plant, using ZOH option
disp('******>'), pause 

figure
ucircle, hold on                 % add unit circle
rlocus(HGp_z)                    % draw root-locus
dzline(0.8),hold off             % add damping-ratio line           
axis([-1.5 1.5 -1 1]);           % get reasonable plot area
title('ex 8.1a - Small-area Root locus for P-only control')

disp('find gain & CL poles for marginal stability')
[kk1,pCL1] = rlocfind(HGp_z)     % user selects point in z-plane
[mag_pCL1,theta_pCL1] = xy2p(pCL1);
disp('******>'), pause 

disp('find gain & CL poles for CL poles with zeta = 0.8')
[kk2,pCL2] = rlocfind(HGp_z)
[mag_pCL2,theta_pCL2] = xy2p(pCL2);
%%%%%%%%%%