function vertlabels(curr_axis,labels)
%
% This function adds vertical labels to a plot 

%%%%%%%%%%%%%%%%% vertlabels.m %%%%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

numTicks=size(labels,1);
% Set the tick locations and remove the labels
set(curr_axis,'XTick',1:numTicks,'XTickLabel','')
%
% Estimate the location of the labels based on the position
% of the xlabel
hx = get(curr_axis,'XLabel');  		% Handle to xlabel
set(hx,'Units','data');
pos = get(hx,'Position');
y = pos(2);

% Place the new labels
for i = 1:numTicks
  txt(i) = text(i,y,labels(i,:));
end
set(txt,'Rotation',90,'HorizontalAlignment','right')
%%%%%%%%%%
